from typing import IO, Any

class PDBRecord:
    name: str
    value: list[str]
    model: list[Any]
    def __init__(self, s: str) -> None: ...
    def __str__(self) -> str: ...
    def is_multiline(self) -> bool: ...
    def extend(self, s: str) -> bool: ...

class PDBHandler:
    records: dict[str, list[PDBRecord]]
    def __init__(self, textfile: None | str | IO[str] = ...) -> None: ...
    def singlemodel(self) -> bool: ...
    def read(self, f: IO[str]) -> None: ...
    def write(self, f: IO[str]) -> None: ...
    def calc_master(self) -> PDBRecord: ...
    def check_master(self) -> bool: ...
    def get_models(self) -> list[list[Any]]: ...
    def add_record(self, record: PDBRecord) -> None: ...
    def add_model(self, model: list[PDBRecord]) -> None: ...
